﻿using System;
using Ueberpruefung;

namespace Eingabeverwaltung.Metamodell
{
	public class Container : Element
	{
		private ADT   adt;
		private Task  task;
		private Proof proof;

		public Container() {}

		public ADT ADT
		{
			get { return adt ; }
			set { adt = value; }
		}
		public Task Task
        {
			get { return task ; }
			set { task = value; }
        }
		public Proof Proof
        {
			get { return proof ; }
			set { proof = value; }
        }

		public string ToString(bool showMetadata)
        {
			string res = "";
			try
			{
				if (adt != null) res += adt.ToString(showMetadata) + "\r\n\r\n"; else { res += "No ADT in Container.\r\n"; return res; }
				if (task != null) res += task.ToString(showMetadata) + "\r\n\r\n"; else { res += "No Task in Container.\r\n"; return res; }
				if (proof != null) res += proof.ToString(showMetadata); else { if (showMetadata) res += "No Proof in Container.\r\n"; return res; }
			}
			catch (NullReferenceException) { res += "NullReferenceException occured while Container.ToString()."; }
			return res;
        }
    }
}
