﻿using Eingabeverwaltung.Metamodell;
using System;

namespace Ueberpruefung.CheckInduction
{
    /// <summary>
    /// checks error 41
    /// @pre: constructors of cases must be set
    /// </summary>
    public class CheckIndCaseType : ElementChecker
    {
        /// <summary>
        /// checks error 41
        /// @pre: constructors of cases must be set
        /// </summary>
        public CheckIndCaseType() : base() { }
        public override bool check(Element e)
        {
            if (e is InductionCase indC)
            {
                bool result = true;
                if (indC.type == "IA")
                    { if (indC.Constructor != null) result = indC.Constructor is BasicConstructor; }
                else if (indC.type == "IS")
                    { if (indC.Constructor != null) result = indC.Constructor is BuildingConstructor; }
                else throw new Exception("Found an unknown induction case type: " + indC.type);
                if (!result) indC.errors.Add(new Error(41));
                return result;
            }
            else throw new InvalidOperationException();
        }
    }
}
