﻿using Eingabeverwaltung.Metamodell;
using System;

namespace Ueberpruefung.CheckInduction
{
    /// <summary>
    /// checks error 31
    /// </summary>
    public class CheckIndVarHasConstructors : ElementChecker
    {
        public CheckIndVarHasConstructors() : base() { }
        public override bool check(Element e)
        {
            if (e is Induction ind)
            {
                if (ind.indVar == null) return true;
                bool result = ind.indVar.sort.GetConstructors().Count > 0;
                if (!result) ind.errors.Add(new Error(31));
                return result;
            }
            else throw new InvalidOperationException();
        }
    }
}
